// GLOBAL VARIABLES
var translatesArray = {};
var addToDefaultFontSize = 0; //0,2 or 4px
var idleTime = 0;
var idleInterval = setInterval(timerIncrement, 120000);

$(document).ready(function () {
    new WOW().init();

    $(this).mousemove(function (e) {
        resetTimer();
    });
    $(this).keypress(function (e) {
        resetTimer();
    });
    //Zero the idle timer on touch events.
    $(this).bind('touchstart', function () {
        resetTimer();
    });
    $(this).bind('touchmove', function () {
        resetTimer();
    });
});

$(window).scroll(function () {
    resetTimer();
});
var defaultFont = parseInt($('html').css('font-size'));

// FONT SIZE
$('.font-size-setter .button').click(function () {
    addToDefaultFontSize = addToDefaultFontSize == 4 ? 0 : addToDefaultFontSize + 2;
    $("html").css('font-size', (defaultFont + addToDefaultFontSize) + 'px');
    if ($('body').hasClass('screen-4k')) {
        $(this).find('img').attr('src', '../global/img/font-size-' + addToDefaultFontSize + '-4k.png')
    } else {
        $(this).find('img').attr('src', '../global/img/font-size-' + addToDefaultFontSize + '.png')
    }

    if ($('.nice-scroll').length)
        $(".nice-scroll").getNiceScroll().resize();
});
function resetTimer() {
    idleTime = 0;
    clearInterval(idleInterval);
    idleInterval = setInterval(timerIncrement, 120000);
}

// ADD &NBSP
function addNbsp(text) {
    myArray = ["1000", "a", "A", "i", "I", "o", "O", "u", "U", "w", "W", "z", "Z", "e", "E", "m.", "aż", "Aż", "bo", "Bo", "by", "By", "iż", "Iż", "ni", "Ni", "że", "Że", "do", "Do", "ku", "Ku", "na", "Na", "od", "Od", "po", "Po", "we", "We", "za", "Za", "ze", "Ze", "hę", "Hę", "no", "No", "ot", "Ot", "aa", "Aa", "aj", "Aj", "am", "Am", "au", "Au", "ba", "Ba", "ee", "Ee", "eh", "Eh", "ej", "Ej", "fe", "Fe", "fi", "Fi", "fi", "Fi", "fu", "Fu", "ha", "Ha", "he", "He", "ho", "Ho", "ii", "Ii", "oj", "Oj", "oo", "Oo", "ot", "Ot", "oż", "Oż", "pa", "Pa", "uf", "Uf", "uu", "Uu", "co", "Co", "ki", "Ki", "se", "Se", "ja", "Ja", "ty", "Ty", "ci", "Ci", "on", "On", "mu", "Mu", "go", "Go", "oń", "Oń", "ją", "Ją", "my", "My", "wy", "Wy", "im", "Im", "je", "Je", "ma", "Ma", "mą", "Mą", "me", "Me", "ów", "Ów", "ta", "Ta", "tę", "Tę", "tą", "Tą", "to", "To", "te", "Te", "tu", "Tu", "al", "Al", "ar", "Ar", "as", "Aa", "at", "At", "bi", "Bi", "er", "Er", "es", "Es", "ew", "Ew", "ez", "Ez", "go", "Go", "id", "Id", "ił", "Ił", "iw", "Iw", "li", "Li", "ok", "Ok", "om", "Om", "op", "Op", "or", "Or", "os", "Os", "oś", "Oś", "oz", "Oz", "ód", "Ód", "ós", "Ós", "su", "Su", "ud", "Ud", "ul", "Ul", "ut", "Ut", "je", "Je", "ma", "Ma", "są", "Są", "lub", "Lub", "ale", "Ale", "czy", "Czy", "nad", "Nad", "pod", "Pod", "bez", "Bez", "nie", "Nie", "tak", "Tak", "albo", "Albo", "więc", "Więc", "lecz", "Lecz", "przez", "Przez", "niech", "Niech", "tylko", "Tylko"];

    if (text !== undefined) {
        for (var i = 0, total = myArray.length; i < total; i++) {
            var myArrayItem = (myArray[i]);
            text = text.replace(new RegExp(' ' + myArrayItem + ' ', 'g'), ' ' + myArrayItem + '&nbsp;');
        }
    }

    return text;
}

// TRANSLATE
var currentLanguage = "pl";
translate();

$(".languages div").on("click", function () {
    $(".languages div").removeClass("selected");
    $(this).addClass("selected");

    currentLanguage = $(this).attr("data-lang");
    translate();
    if ($('.nice-scroll').length)
        $(".nice-scroll").getNiceScroll().resize();
});

function translate() {

    if (currentLanguage === "pl") {
        translatesArray = pl;
    } else if (currentLanguage === "en") {
        translatesArray = en;
    } else if (currentLanguage === "de") {
        translatesArray = de;
    }

    $('*[data-translate]').each(function () {
        var attrValue = $(this).attr('data-translate');
        $("*[data-translate='" + attrValue + "']").html(addNbsp(translatesArray[attrValue]));
    });
}

// REDIRECT TO OTHER PAGE
var currentPage = "start-page";
$(document).on("click", "*[data-goto]", function () {
    var destinationPage = $(this).attr("data-goto");
    goto(destinationPage);

    if (destinationPage == "list-page") {
        $("#header .title").html("ENCYKLOPEDIA");
    } else if (destinationPage == "start-page") {
        $("#header .title").html("");
        $("#header .title").attr("data-translate", '');
        $("body > .title").html("");
        $("body > .title").attr("data-translate", '');
    }
});

function goto(destinationPage) {
    $("#" + currentPage).animate({opacity: 0}, 500);
    $("#" + destinationPage).animate({opacity: 1}, 500);

    $("#" + currentPage).css("z-index", 0);
    $("#" + destinationPage).css("z-index", 10);

    currentPage = destinationPage;
}

function timerIncrement() {
    idleTime = idleTime + 1;
    if (idleTime == 1) {
        /*if (currentPage != "start-page") {
         goto("start-page");
         $("#header .title").html("");
         }
         $("html").css('font-size', '14px');
         $(this).find('img').attr('src', '../global/img/font-size-0.png')
         
         if ($('.nice-scroll').length)
         $(".nice-scroll").getNiceScroll().resize();
         if ($('#pinch').length) {
         var pz = PinchZoomer.get("pinch");
         pz.zoom(pz._vars.minZoom);
         }
         
         
         $('.modal').each(function () {
         $(this).iziModal('close');
         });
         $('.legend-close').click(); //map
         $('.legend-item.active').click();
         
         $('.button[data-action="reload"]').click(); //video
         if ($('#timeline-app').length)
         window.scrollTo({top: $(document).height(), behavior: 'smooth'});*/
        location.reload();
    }
}

$("*[data-index]").on("click", function () {
    var defIndex = 's' + $(this).attr("data-index");
    loadDefinition(defIndex);
});

// NICE SCROLL
if ($('.nice-scroll').length) {
    initNiceScroll();
}

function initNiceScroll() {
    $(".nice-scroll").niceScroll({
        cursorcolor: "#dad1b9", // change cursor color in hex
        cursorwidth: "20px", // cursor width in pixel (you can also write "5px")
        cursorborder: "0px solid transparent", // css definition for cursor border
        cursorborderradius: "0px", // border radius in pixel for cursor
        cursordragontouch: true,
        emulatetouch: true, // enable cursor-drag scrolling like touch devices in desktop computer
        hwacceleration: true, // use hardware accelerated scroll when supported
        autohidemode: false, // how hide the scrollbar works, possible values: 
        background: "",
        railpadding: {top: 0, right: 15, left: 0, bottom: 0},
    });
}

// PLAYER
if ($('.page.player-page').length) {

    var player_page = $('.page.player-page');
    player_page.append("<div class='progress-bar-container'><div class='progress-bar'><div class='time-bar'></div></div></div>");

    var video = $(".player-page video");
    var play_button = $(".button[data-action='play']");
    var pause_button = $(".button[data-action='pause']");
    var progress_bar_container = $('.progress-bar-container');
    var progress_bar = $('.progress-bar');
    var time_bar = $('.time-bar');

    video.bind("ended", function () {
        play_button.show();
        pause_button.hide();
        time_bar.css('width', '0%');
    });

    video.on('timeupdate', function () {
        var currentPos = video[0].currentTime; //Get currenttime
        var maxduration = video[0].duration; //Get video duration
        var percentage = 100 * currentPos / maxduration; //in %
        time_bar.css('width', percentage + '%');
        resetTimer();
    });

    var timeDrag = false;   /* Drag status */
    progress_bar_container.mousedown(function (e) {
        timeDrag = true;
        updatebar(e.pageX);
    });
    $(document).mouseup(function (e) {
        if (timeDrag) {
            timeDrag = false;
            updatebar(e.pageX);
        }
    });
    $(document).mousemove(function (e) {
        if (timeDrag) {
            updatebar(e.pageX);
        }
    });

//update Progress Bar control
    var updatebar = function (x) {
        var maxduration = video[0].duration; //Video duraiton
        var position = x - progress_bar.offset().left; //Click pos
        var percentage = 100 * position / progress_bar.width();

        //Check within range
        if (percentage > 100) {
            percentage = 100;
        }
        if (percentage < 0) {
            percentage = 0;
        }

        //Update progress bar and video currenttime
        time_bar.css('width', percentage + '%');
        video[0].currentTime = maxduration * percentage / 100;
    };

    $("*[data-action]").on("click", function () {
        var action = $(this).attr("data-action");

        if (action == "play") {
            video.trigger('play');
            play_button.hide();
            pause_button.show();
        } else if (action == "reload") {
            video[0].load();
            play_button.show();
            pause_button.hide();
            time_bar.css('width', '0%');
        } else if (action == "pause") {
            video.trigger('pause');
            play_button.show();
            pause_button.hide();
        }
    });

}



// ENCYCLOPEDIA
if ($('body#encyclopedia').length) {
    loadDefinitions();
    $("#header .title").html("");
}

function loadDefinitions() {
    var html = "";
    var current_group = "";
    var current_group2 = "";
    var current_group3 = "";
    var definitions_counter = 0;
    $.each(translatesArray, function (key, value) {
        if (key.indexOf("_name") >= 0) {
            var keyArray = key.split("_");
            var defIndex = keyArray[0];

            // GROUP
            if (current_group != translatesArray[defIndex + "_group"]) {

                if (current_group != "") {
                    html += "</div>";
                }

                html += "<div class='definitions-group'>";

                var isGroup = translatesArray[defIndex + "_group"] != undefined;

                if (isGroup) {
                    html += "<div class='definition-group-title'><div class='definition-block' data-translate='" + defIndex + "_group" + "'>" + translatesArray[defIndex + "_group"] + "</div></div>";
                }

            }

            // GROUP_2
            var isGroup2 = translatesArray[defIndex + "_group2"] != undefined;
            if (current_group2 != translatesArray[defIndex + "_group2"]) {

                if (isGroup2) {
                    html += "<div class='definition-group2-title'><div class='definition-block' data-translate='" + defIndex + "_group2" + "'>" + translatesArray[defIndex + "_group2"] + "</div></div>";
                }
            }

            // GROUP_3
            var isGroup3 = translatesArray[defIndex + "_group3"] != undefined;
            if (current_group3 != translatesArray[defIndex + "_group3"]) {

                if (isGroup3) {
                    html += "<div class='definition-group3-title'><div class='definition-block' data-translate='" + defIndex + "_group3" + "'>" + translatesArray[defIndex + "_group3"] + "</div></div>";
                }
            }

            current_group = translatesArray[defIndex + "_group"];
            current_group2 = translatesArray[defIndex + "_group2"];
            current_group3 = translatesArray[defIndex + "_group3"];

            html += "<div class='definition " + ((isGroup2) ? "tab2 " : "") + ((isGroup3) ? "tab3 " : "") + "' data-index='" + defIndex + "'><div class='definition-block'><img src='../global/img/icons/ico_arrow_def.svg'/><span data-translate='" + key + "'>" + value + "</span></div></div>";

            definitions_counter++;
        }

    });
    html += "</div>";
    $("#encyclopedia #list-page .list").html(html);
    $("#encyclopedia #footer #next-button").attr("data-max", definitions_counter);
}

$(document).on("click", "#encyclopedia #list-page .list .definition", function () {
    $(this).addClass("selected");
    var defIndex = $(this).attr("data-index");
    loadDefinition(defIndex);
    goto("definition-page");

    setTimeout(function () {
        $("#encyclopedia #list-page .list .definition").removeClass("selected");
    }, 700);
});

function loadDefinition(defIndex) {
    var index = defIndex.replace('s', '');
    $('#prev-button').attr('data-index', (parseInt(index) - 1));
    $('#next-button').attr('data-index', (parseInt(index) + 1));
    var max = $('#next-button').attr('data-max');
    $('#prev-button').show();
    $('#next-button').show();
    if (index == 1) {
        $('#prev-button').hide();
    }
    if (index == max) {
        $('#next-button').hide();
    }

    $("#encyclopedia #definition-page h1").html(translatesArray[defIndex + "_name"]);
    $("#encyclopedia #definition-page h1").attr('data-translate', defIndex + "_name");
    $("#encyclopedia #definition-page .text").html(addNbsp(translatesArray[defIndex + "_desc"]));
    $("#encyclopedia #definition-page .text").attr('data-translate', defIndex + "_desc");

    if (Array.isArray(translatesArray[defIndex + "_img"])) {
        $("#encyclopedia #definition-page .image img").attr("src", "");
        var slider = '';
        slider += '<div class="swiper-container-' + defIndex + '"><div class="swiper-wrapper">';


        translatesArray[defIndex + "_img"].forEach(function (imageUrl, index) {
            slider += '<div class="swiper-slide"><img src="' + imageUrl + '" /></div>';
        });
        slider += '</div><div class="swiper-pagination swiper-pagination-' + defIndex + '"></div><div class="swiper-button-prev swiper-button-prev-' + defIndex + '"></div><div class="swiper-button-next swiper-button-next-' + defIndex + '"></div></div>';
        $("#encyclopedia #definition-page .image").html(slider);
        $("#encyclopedia #definition-page .left-side").removeClass("center");
        $("#encyclopedia #definition-page .right-side").show();

        var swiper = new Swiper('.swiper-container-' + defIndex, {
            // Optional parameters
            loop: true,

            pagination: {
                el: '.swiper-pagination',
                clickable: true,
                renderBullet: function (index, className) {
                    return '<span class="' + className + '">' + (index + 1) + '</span>';
                },
            },

            // Navigation arrows
            navigation: {
                nextEl: '.swiper-button-next-' + defIndex,
                prevEl: '.swiper-button-prev-' + defIndex,
            }

        });
    } else if (translatesArray[defIndex + "_img"] != "") {
        $("#encyclopedia #definition-page .image").html('<img src="" />');
        $("#encyclopedia #definition-page .image img").attr("src", "");
        $("#encyclopedia #definition-page .image img").attr("src", translatesArray[defIndex + "_img"]);
        $("#encyclopedia #definition-page .left-side").removeClass("center");
        $("#encyclopedia #definition-page .right-side").show();

    } else {
        $("#encyclopedia #definition-page .left-side").addClass("center");
        $("#encyclopedia #definition-page .right-side").hide();
    }

    $("#encyclopedia #definition-page .nice-scroll").getNiceScroll().resize();
    $("#encyclopedia #definition-page .nice-scroll").scrollTop(0);

    //breadcrumbs
    var breadcrumbs = "";
    breadcrumbs += translatesArray[defIndex + "_group"] != undefined ? '<span data-translate="' + defIndex + "_group" + '">' + translatesArray[defIndex + "_group"] + '</span>' + "&nbsp;/&nbsp;" : "";
    breadcrumbs += '<span data-translate="' + defIndex + "_name" + '">' + translatesArray[defIndex + "_name"] + '</span>';

    $("#header .title").html(breadcrumbs);
}
function modalInit() {
    $(".modal").iziModal({
        arrowKeys: false,
        navigateCaption: false,
        width: 1655,
        padding: 70,
        autoOpen: 0,
        restoreDefaultContent: true,
        overlayClose: true,
        transitionInOverlay: false,
        transitionOutOverlay: false,
        loop: true,
        onResize: function (modal) {
        },
        onClosed: function (modal) {
        },
        afterRender: function (modal) {
        },
        onOpening: function (modal) {
            translate();
            if ($('.iziModal-content .nice-scroll').length) {
                $('#' + modal.id).find(".nice-scroll").niceScroll({
                    cursorcolor: "#dad1b9", // change cursor color in hex
                    cursorwidth: "20px", // cursor width in pixel (you can also write "5px")
                    cursorborder: "0px solid transparent", // css definition for cursor border
                    cursorborderradius: "0px", // border radius in pixel for cursor
                    cursordragontouch: true,
                    emulatetouch: true, // enable cursor-drag scrolling like touch devices in desktop computer
                    hwacceleration: true, // use hardware accelerated scroll when supported
                    autohidemode: false, // how hide the scrollbar works, possible values: 
                    background: "",
                    railpadding: {top: 0, right: 15, left: 0, bottom: 0},
                });
            }
        },
        onClosing: function (modal) {
            if ($('.iziModal-content .nice-scroll').length) {
                $(".iziModal-content .nice-scroll").getNiceScroll().remove();
            }
        }

    });
}

$('.arrowTop').click(function () {
    var pz = PinchZoomer.get("pinch");
    var move = 400;
    var matrix = $('.pinch').css('transform');
    var values = matrix.match(/-?[\d\.]+/g);
    var currentTop = parseInt(values[5]);
    var change = currentTop + move;
    pz.y(change);
});

$('.arrowBottom').click(function () {
    var pz = PinchZoomer.get("pinch");
    var move = 400;
    var matrix = $('.pinch').css('transform');
    var values = matrix.match(/-?[\d\.]+/g);
    var currentTop = parseInt(values[5]);
    var change = currentTop - move;
    pz.y(change);
});

$('.arrowLeft').click(function () {
    var pz = PinchZoomer.get("pinch");
    var move = 400;
    var matrix = $('.pinch').css('transform');
    var values = matrix.match(/-?[\d\.]+/g);
    var currentLeft = parseInt(values[4]);
    var change = currentLeft + move;
    pz.x(change);
});

$('.arrowRight').click(function () {
    var pz = PinchZoomer.get("pinch");
    var move = 400;
    var matrix = $('.pinch').css('transform');
    var values = matrix.match(/-?[\d\.]+/g);
    var currentLeft = parseInt(values[4]);
    var change = currentLeft - move;
    pz.x(change);
});